// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetAPITokenListByAdminIDJSONReader is a Reader for the GetAPITokenListByAdminIDJSON structure.
type GetAPITokenListByAdminIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAPITokenListByAdminIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAPITokenListByAdminIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAPITokenListByAdminIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAPITokenListByAdminIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAPITokenListByAdminIDJSONOK creates a GetAPITokenListByAdminIDJSONOK with default headers values
func NewGetAPITokenListByAdminIDJSONOK() *GetAPITokenListByAdminIDJSONOK {
	return &GetAPITokenListByAdminIDJSONOK{}
}

/* GetAPITokenListByAdminIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAPITokenListByAdminIDJSONOK struct {
	Payload interface{}
}

func (o *GetAPITokenListByAdminIDJSONOK) Error() string {
	return fmt.Sprintf("[GET /setting/admins/{adminId}/apitokens?__json=][%d] getApiTokenListByAdminIdJsonOK  %+v", 200, o.Payload)
}
func (o *GetAPITokenListByAdminIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetAPITokenListByAdminIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAPITokenListByAdminIDJSONTooManyRequests creates a GetAPITokenListByAdminIDJSONTooManyRequests with default headers values
func NewGetAPITokenListByAdminIDJSONTooManyRequests() *GetAPITokenListByAdminIDJSONTooManyRequests {
	return &GetAPITokenListByAdminIDJSONTooManyRequests{}
}

/* GetAPITokenListByAdminIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAPITokenListByAdminIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetAPITokenListByAdminIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/admins/{adminId}/apitokens?__json=][%d] getApiTokenListByAdminIdJsonTooManyRequests ", 429)
}

func (o *GetAPITokenListByAdminIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAPITokenListByAdminIDJSONDefault creates a GetAPITokenListByAdminIDJSONDefault with default headers values
func NewGetAPITokenListByAdminIDJSONDefault(code int) *GetAPITokenListByAdminIDJSONDefault {
	return &GetAPITokenListByAdminIDJSONDefault{
		_statusCode: code,
	}
}

/* GetAPITokenListByAdminIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetAPITokenListByAdminIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get Api token list by admin Id Json default response
func (o *GetAPITokenListByAdminIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetAPITokenListByAdminIDJSONDefault) Error() string {
	return fmt.Sprintf("[GET /setting/admins/{adminId}/apitokens?__json=][%d] getApiTokenListByAdminIdJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetAPITokenListByAdminIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAPITokenListByAdminIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
