// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetAPITokenListJSONReader is a Reader for the GetAPITokenListJSON structure.
type GetAPITokenListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAPITokenListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAPITokenListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAPITokenListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAPITokenListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAPITokenListJSONOK creates a GetAPITokenListJSONOK with default headers values
func NewGetAPITokenListJSONOK() *GetAPITokenListJSONOK {
	return &GetAPITokenListJSONOK{}
}

/* GetAPITokenListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAPITokenListJSONOK struct {
	Payload interface{}
}

func (o *GetAPITokenListJSONOK) Error() string {
	return fmt.Sprintf("[GET /setting/admins/apitokens?__json=][%d] getApiTokenListJsonOK  %+v", 200, o.Payload)
}
func (o *GetAPITokenListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetAPITokenListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAPITokenListJSONTooManyRequests creates a GetAPITokenListJSONTooManyRequests with default headers values
func NewGetAPITokenListJSONTooManyRequests() *GetAPITokenListJSONTooManyRequests {
	return &GetAPITokenListJSONTooManyRequests{}
}

/* GetAPITokenListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAPITokenListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetAPITokenListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/admins/apitokens?__json=][%d] getApiTokenListJsonTooManyRequests ", 429)
}

func (o *GetAPITokenListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAPITokenListJSONDefault creates a GetAPITokenListJSONDefault with default headers values
func NewGetAPITokenListJSONDefault(code int) *GetAPITokenListJSONDefault {
	return &GetAPITokenListJSONDefault{
		_statusCode: code,
	}
}

/* GetAPITokenListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetAPITokenListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get Api token list Json default response
func (o *GetAPITokenListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetAPITokenListJSONDefault) Error() string {
	return fmt.Sprintf("[GET /setting/admins/apitokens?__json=][%d] getApiTokenListJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetAPITokenListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAPITokenListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
