// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetAppliesToFunctionByIDJSONReader is a Reader for the GetAppliesToFunctionByIDJSON structure.
type GetAppliesToFunctionByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAppliesToFunctionByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAppliesToFunctionByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAppliesToFunctionByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAppliesToFunctionByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAppliesToFunctionByIDJSONOK creates a GetAppliesToFunctionByIDJSONOK with default headers values
func NewGetAppliesToFunctionByIDJSONOK() *GetAppliesToFunctionByIDJSONOK {
	return &GetAppliesToFunctionByIDJSONOK{}
}

/* GetAppliesToFunctionByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAppliesToFunctionByIDJSONOK struct {
	Payload interface{}
}

func (o *GetAppliesToFunctionByIDJSONOK) Error() string {
	return fmt.Sprintf("[GET /setting/functions/{id}?__json=][%d] getAppliesToFunctionByIdJsonOK  %+v", 200, o.Payload)
}
func (o *GetAppliesToFunctionByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetAppliesToFunctionByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAppliesToFunctionByIDJSONTooManyRequests creates a GetAppliesToFunctionByIDJSONTooManyRequests with default headers values
func NewGetAppliesToFunctionByIDJSONTooManyRequests() *GetAppliesToFunctionByIDJSONTooManyRequests {
	return &GetAppliesToFunctionByIDJSONTooManyRequests{}
}

/* GetAppliesToFunctionByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAppliesToFunctionByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetAppliesToFunctionByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/functions/{id}?__json=][%d] getAppliesToFunctionByIdJsonTooManyRequests ", 429)
}

func (o *GetAppliesToFunctionByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAppliesToFunctionByIDJSONDefault creates a GetAppliesToFunctionByIDJSONDefault with default headers values
func NewGetAppliesToFunctionByIDJSONDefault(code int) *GetAppliesToFunctionByIDJSONDefault {
	return &GetAppliesToFunctionByIDJSONDefault{
		_statusCode: code,
	}
}

/* GetAppliesToFunctionByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetAppliesToFunctionByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get applies to function by Id Json default response
func (o *GetAppliesToFunctionByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetAppliesToFunctionByIDJSONDefault) Error() string {
	return fmt.Sprintf("[GET /setting/functions/{id}?__json=][%d] getAppliesToFunctionByIdJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetAppliesToFunctionByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAppliesToFunctionByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
