// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetAwsAccountIDJSONReader is a Reader for the GetAwsAccountIDJSON structure.
type GetAwsAccountIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAwsAccountIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAwsAccountIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAwsAccountIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAwsAccountIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAwsAccountIDJSONOK creates a GetAwsAccountIDJSONOK with default headers values
func NewGetAwsAccountIDJSONOK() *GetAwsAccountIDJSONOK {
	return &GetAwsAccountIDJSONOK{}
}

/* GetAwsAccountIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAwsAccountIDJSONOK struct {
	Payload interface{}
}

func (o *GetAwsAccountIDJSONOK) Error() string {
	return fmt.Sprintf("[GET /aws/accountId?__json=][%d] getAwsAccountIdJsonOK  %+v", 200, o.Payload)
}
func (o *GetAwsAccountIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetAwsAccountIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAwsAccountIDJSONTooManyRequests creates a GetAwsAccountIDJSONTooManyRequests with default headers values
func NewGetAwsAccountIDJSONTooManyRequests() *GetAwsAccountIDJSONTooManyRequests {
	return &GetAwsAccountIDJSONTooManyRequests{}
}

/* GetAwsAccountIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAwsAccountIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetAwsAccountIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /aws/accountId?__json=][%d] getAwsAccountIdJsonTooManyRequests ", 429)
}

func (o *GetAwsAccountIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAwsAccountIDJSONDefault creates a GetAwsAccountIDJSONDefault with default headers values
func NewGetAwsAccountIDJSONDefault(code int) *GetAwsAccountIDJSONDefault {
	return &GetAwsAccountIDJSONDefault{
		_statusCode: code,
	}
}

/* GetAwsAccountIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetAwsAccountIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get aws account Id Json default response
func (o *GetAwsAccountIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetAwsAccountIDJSONDefault) Error() string {
	return fmt.Sprintf("[GET /aws/accountId?__json=][%d] getAwsAccountIdJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetAwsAccountIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAwsAccountIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
