// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetCollectorVersionListJSONReader is a Reader for the GetCollectorVersionListJSON structure.
type GetCollectorVersionListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCollectorVersionListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetCollectorVersionListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetCollectorVersionListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetCollectorVersionListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetCollectorVersionListJSONOK creates a GetCollectorVersionListJSONOK with default headers values
func NewGetCollectorVersionListJSONOK() *GetCollectorVersionListJSONOK {
	return &GetCollectorVersionListJSONOK{}
}

/* GetCollectorVersionListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetCollectorVersionListJSONOK struct {
	Payload interface{}
}

func (o *GetCollectorVersionListJSONOK) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/versions?__json=][%d] getCollectorVersionListJsonOK  %+v", 200, o.Payload)
}
func (o *GetCollectorVersionListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetCollectorVersionListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCollectorVersionListJSONTooManyRequests creates a GetCollectorVersionListJSONTooManyRequests with default headers values
func NewGetCollectorVersionListJSONTooManyRequests() *GetCollectorVersionListJSONTooManyRequests {
	return &GetCollectorVersionListJSONTooManyRequests{}
}

/* GetCollectorVersionListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetCollectorVersionListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetCollectorVersionListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/versions?__json=][%d] getCollectorVersionListJsonTooManyRequests ", 429)
}

func (o *GetCollectorVersionListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetCollectorVersionListJSONDefault creates a GetCollectorVersionListJSONDefault with default headers values
func NewGetCollectorVersionListJSONDefault(code int) *GetCollectorVersionListJSONDefault {
	return &GetCollectorVersionListJSONDefault{
		_statusCode: code,
	}
}

/* GetCollectorVersionListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetCollectorVersionListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get collector version list Json default response
func (o *GetCollectorVersionListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetCollectorVersionListJSONDefault) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/versions?__json=][%d] getCollectorVersionListJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetCollectorVersionListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetCollectorVersionListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
