// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetDataSourceOverviewGraphListJSONReader is a Reader for the GetDataSourceOverviewGraphListJSON structure.
type GetDataSourceOverviewGraphListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDataSourceOverviewGraphListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDataSourceOverviewGraphListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDataSourceOverviewGraphListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDataSourceOverviewGraphListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDataSourceOverviewGraphListJSONOK creates a GetDataSourceOverviewGraphListJSONOK with default headers values
func NewGetDataSourceOverviewGraphListJSONOK() *GetDataSourceOverviewGraphListJSONOK {
	return &GetDataSourceOverviewGraphListJSONOK{}
}

/* GetDataSourceOverviewGraphListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDataSourceOverviewGraphListJSONOK struct {
	Payload interface{}
}

func (o *GetDataSourceOverviewGraphListJSONOK) Error() string {
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs?__json=][%d] getDataSourceOverviewGraphListJsonOK  %+v", 200, o.Payload)
}
func (o *GetDataSourceOverviewGraphListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDataSourceOverviewGraphListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDataSourceOverviewGraphListJSONTooManyRequests creates a GetDataSourceOverviewGraphListJSONTooManyRequests with default headers values
func NewGetDataSourceOverviewGraphListJSONTooManyRequests() *GetDataSourceOverviewGraphListJSONTooManyRequests {
	return &GetDataSourceOverviewGraphListJSONTooManyRequests{}
}

/* GetDataSourceOverviewGraphListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDataSourceOverviewGraphListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetDataSourceOverviewGraphListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs?__json=][%d] getDataSourceOverviewGraphListJsonTooManyRequests ", 429)
}

func (o *GetDataSourceOverviewGraphListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDataSourceOverviewGraphListJSONDefault creates a GetDataSourceOverviewGraphListJSONDefault with default headers values
func NewGetDataSourceOverviewGraphListJSONDefault(code int) *GetDataSourceOverviewGraphListJSONDefault {
	return &GetDataSourceOverviewGraphListJSONDefault{
		_statusCode: code,
	}
}

/* GetDataSourceOverviewGraphListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDataSourceOverviewGraphListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get data source overview graph list Json default response
func (o *GetDataSourceOverviewGraphListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDataSourceOverviewGraphListJSONDefault) Error() string {
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs?__json=][%d] getDataSourceOverviewGraphListJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetDataSourceOverviewGraphListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDataSourceOverviewGraphListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
