// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetDeviceByIDJSONReader is a Reader for the GetDeviceByIDJSON structure.
type GetDeviceByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceByIDJSONOK creates a GetDeviceByIDJSONOK with default headers values
func NewGetDeviceByIDJSONOK() *GetDeviceByIDJSONOK {
	return &GetDeviceByIDJSONOK{}
}

/* GetDeviceByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceByIDJSONOK struct {
	Payload interface{}
}

func (o *GetDeviceByIDJSONOK) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}?__json=][%d] getDeviceByIdJsonOK  %+v", 200, o.Payload)
}
func (o *GetDeviceByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDeviceByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceByIDJSONTooManyRequests creates a GetDeviceByIDJSONTooManyRequests with default headers values
func NewGetDeviceByIDJSONTooManyRequests() *GetDeviceByIDJSONTooManyRequests {
	return &GetDeviceByIDJSONTooManyRequests{}
}

/* GetDeviceByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetDeviceByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}?__json=][%d] getDeviceByIdJsonTooManyRequests ", 429)
}

func (o *GetDeviceByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceByIDJSONDefault creates a GetDeviceByIDJSONDefault with default headers values
func NewGetDeviceByIDJSONDefault(code int) *GetDeviceByIDJSONDefault {
	return &GetDeviceByIDJSONDefault{
		_statusCode: code,
	}
}

/* GetDeviceByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get device by Id Json default response
func (o *GetDeviceByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceByIDJSONDefault) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}?__json=][%d] getDeviceByIdJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetDeviceByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
