// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetDeviceConfigSourceConfigListJSONReader is a Reader for the GetDeviceConfigSourceConfigListJSON structure.
type GetDeviceConfigSourceConfigListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceConfigSourceConfigListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceConfigSourceConfigListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceConfigSourceConfigListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceConfigSourceConfigListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceConfigSourceConfigListJSONOK creates a GetDeviceConfigSourceConfigListJSONOK with default headers values
func NewGetDeviceConfigSourceConfigListJSONOK() *GetDeviceConfigSourceConfigListJSONOK {
	return &GetDeviceConfigSourceConfigListJSONOK{}
}

/* GetDeviceConfigSourceConfigListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceConfigSourceConfigListJSONOK struct {
	Payload interface{}
}

func (o *GetDeviceConfigSourceConfigListJSONOK) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/config?__json=][%d] getDeviceConfigSourceConfigListJsonOK  %+v", 200, o.Payload)
}
func (o *GetDeviceConfigSourceConfigListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDeviceConfigSourceConfigListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceConfigSourceConfigListJSONTooManyRequests creates a GetDeviceConfigSourceConfigListJSONTooManyRequests with default headers values
func NewGetDeviceConfigSourceConfigListJSONTooManyRequests() *GetDeviceConfigSourceConfigListJSONTooManyRequests {
	return &GetDeviceConfigSourceConfigListJSONTooManyRequests{}
}

/* GetDeviceConfigSourceConfigListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceConfigSourceConfigListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetDeviceConfigSourceConfigListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/config?__json=][%d] getDeviceConfigSourceConfigListJsonTooManyRequests ", 429)
}

func (o *GetDeviceConfigSourceConfigListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceConfigSourceConfigListJSONDefault creates a GetDeviceConfigSourceConfigListJSONDefault with default headers values
func NewGetDeviceConfigSourceConfigListJSONDefault(code int) *GetDeviceConfigSourceConfigListJSONDefault {
	return &GetDeviceConfigSourceConfigListJSONDefault{
		_statusCode: code,
	}
}

/* GetDeviceConfigSourceConfigListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceConfigSourceConfigListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get device config source config list Json default response
func (o *GetDeviceConfigSourceConfigListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceConfigSourceConfigListJSONDefault) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{instanceId}/config?__json=][%d] getDeviceConfigSourceConfigListJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetDeviceConfigSourceConfigListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceConfigSourceConfigListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
