// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetDeviceDatasourceInstanceGraphDataJSONReader is a Reader for the GetDeviceDatasourceInstanceGraphDataJSON structure.
type GetDeviceDatasourceInstanceGraphDataJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceDatasourceInstanceGraphDataJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceDatasourceInstanceGraphDataJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceDatasourceInstanceGraphDataJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceDatasourceInstanceGraphDataJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceDatasourceInstanceGraphDataJSONOK creates a GetDeviceDatasourceInstanceGraphDataJSONOK with default headers values
func NewGetDeviceDatasourceInstanceGraphDataJSONOK() *GetDeviceDatasourceInstanceGraphDataJSONOK {
	return &GetDeviceDatasourceInstanceGraphDataJSONOK{}
}

/* GetDeviceDatasourceInstanceGraphDataJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceDatasourceInstanceGraphDataJSONOK struct {
	Payload interface{}
}

func (o *GetDeviceDatasourceInstanceGraphDataJSONOK) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{id}/graphs/{graphId}/data?__json=][%d] getDeviceDatasourceInstanceGraphDataJsonOK  %+v", 200, o.Payload)
}
func (o *GetDeviceDatasourceInstanceGraphDataJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDeviceDatasourceInstanceGraphDataJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceDatasourceInstanceGraphDataJSONTooManyRequests creates a GetDeviceDatasourceInstanceGraphDataJSONTooManyRequests with default headers values
func NewGetDeviceDatasourceInstanceGraphDataJSONTooManyRequests() *GetDeviceDatasourceInstanceGraphDataJSONTooManyRequests {
	return &GetDeviceDatasourceInstanceGraphDataJSONTooManyRequests{}
}

/* GetDeviceDatasourceInstanceGraphDataJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceDatasourceInstanceGraphDataJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetDeviceDatasourceInstanceGraphDataJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{id}/graphs/{graphId}/data?__json=][%d] getDeviceDatasourceInstanceGraphDataJsonTooManyRequests ", 429)
}

func (o *GetDeviceDatasourceInstanceGraphDataJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceDatasourceInstanceGraphDataJSONDefault creates a GetDeviceDatasourceInstanceGraphDataJSONDefault with default headers values
func NewGetDeviceDatasourceInstanceGraphDataJSONDefault(code int) *GetDeviceDatasourceInstanceGraphDataJSONDefault {
	return &GetDeviceDatasourceInstanceGraphDataJSONDefault{
		_statusCode: code,
	}
}

/* GetDeviceDatasourceInstanceGraphDataJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceDatasourceInstanceGraphDataJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get device datasource instance graph data Json default response
func (o *GetDeviceDatasourceInstanceGraphDataJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceDatasourceInstanceGraphDataJSONDefault) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{hdsId}/instances/{id}/graphs/{graphId}/data?__json=][%d] getDeviceDatasourceInstanceGraphDataJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetDeviceDatasourceInstanceGraphDataJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceDatasourceInstanceGraphDataJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
