// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetDeviceDatasourceInstanceListJSONReader is a Reader for the GetDeviceDatasourceInstanceListJSON structure.
type GetDeviceDatasourceInstanceListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceDatasourceInstanceListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceDatasourceInstanceListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceDatasourceInstanceListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceDatasourceInstanceListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceDatasourceInstanceListJSONOK creates a GetDeviceDatasourceInstanceListJSONOK with default headers values
func NewGetDeviceDatasourceInstanceListJSONOK() *GetDeviceDatasourceInstanceListJSONOK {
	return &GetDeviceDatasourceInstanceListJSONOK{}
}

/* GetDeviceDatasourceInstanceListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceDatasourceInstanceListJSONOK struct {
	Payload interface{}
}

func (o *GetDeviceDatasourceInstanceListJSONOK) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{hdsId}/instances?__json=][%d] getDeviceDatasourceInstanceListJsonOK  %+v", 200, o.Payload)
}
func (o *GetDeviceDatasourceInstanceListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDeviceDatasourceInstanceListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceDatasourceInstanceListJSONTooManyRequests creates a GetDeviceDatasourceInstanceListJSONTooManyRequests with default headers values
func NewGetDeviceDatasourceInstanceListJSONTooManyRequests() *GetDeviceDatasourceInstanceListJSONTooManyRequests {
	return &GetDeviceDatasourceInstanceListJSONTooManyRequests{}
}

/* GetDeviceDatasourceInstanceListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceDatasourceInstanceListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetDeviceDatasourceInstanceListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{hdsId}/instances?__json=][%d] getDeviceDatasourceInstanceListJsonTooManyRequests ", 429)
}

func (o *GetDeviceDatasourceInstanceListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceDatasourceInstanceListJSONDefault creates a GetDeviceDatasourceInstanceListJSONDefault with default headers values
func NewGetDeviceDatasourceInstanceListJSONDefault(code int) *GetDeviceDatasourceInstanceListJSONDefault {
	return &GetDeviceDatasourceInstanceListJSONDefault{
		_statusCode: code,
	}
}

/* GetDeviceDatasourceInstanceListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceDatasourceInstanceListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get device datasource instance list Json default response
func (o *GetDeviceDatasourceInstanceListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceDatasourceInstanceListJSONDefault) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{hdsId}/instances?__json=][%d] getDeviceDatasourceInstanceListJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetDeviceDatasourceInstanceListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceDatasourceInstanceListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
