// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetDeviceGroupPropertyByNameJSONReader is a Reader for the GetDeviceGroupPropertyByNameJSON structure.
type GetDeviceGroupPropertyByNameJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceGroupPropertyByNameJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceGroupPropertyByNameJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceGroupPropertyByNameJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceGroupPropertyByNameJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceGroupPropertyByNameJSONOK creates a GetDeviceGroupPropertyByNameJSONOK with default headers values
func NewGetDeviceGroupPropertyByNameJSONOK() *GetDeviceGroupPropertyByNameJSONOK {
	return &GetDeviceGroupPropertyByNameJSONOK{}
}

/* GetDeviceGroupPropertyByNameJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceGroupPropertyByNameJSONOK struct {
	Payload interface{}
}

func (o *GetDeviceGroupPropertyByNameJSONOK) Error() string {
	return fmt.Sprintf("[GET /device/groups/{gid}/properties/{name}?__json=][%d] getDeviceGroupPropertyByNameJsonOK  %+v", 200, o.Payload)
}
func (o *GetDeviceGroupPropertyByNameJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDeviceGroupPropertyByNameJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceGroupPropertyByNameJSONTooManyRequests creates a GetDeviceGroupPropertyByNameJSONTooManyRequests with default headers values
func NewGetDeviceGroupPropertyByNameJSONTooManyRequests() *GetDeviceGroupPropertyByNameJSONTooManyRequests {
	return &GetDeviceGroupPropertyByNameJSONTooManyRequests{}
}

/* GetDeviceGroupPropertyByNameJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceGroupPropertyByNameJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetDeviceGroupPropertyByNameJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/groups/{gid}/properties/{name}?__json=][%d] getDeviceGroupPropertyByNameJsonTooManyRequests ", 429)
}

func (o *GetDeviceGroupPropertyByNameJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceGroupPropertyByNameJSONDefault creates a GetDeviceGroupPropertyByNameJSONDefault with default headers values
func NewGetDeviceGroupPropertyByNameJSONDefault(code int) *GetDeviceGroupPropertyByNameJSONDefault {
	return &GetDeviceGroupPropertyByNameJSONDefault{
		_statusCode: code,
	}
}

/* GetDeviceGroupPropertyByNameJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceGroupPropertyByNameJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get device group property by name Json default response
func (o *GetDeviceGroupPropertyByNameJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceGroupPropertyByNameJSONDefault) Error() string {
	return fmt.Sprintf("[GET /device/groups/{gid}/properties/{name}?__json=][%d] getDeviceGroupPropertyByNameJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetDeviceGroupPropertyByNameJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceGroupPropertyByNameJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
