// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetDevicePropertyListJSONReader is a Reader for the GetDevicePropertyListJSON structure.
type GetDevicePropertyListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDevicePropertyListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDevicePropertyListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDevicePropertyListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDevicePropertyListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDevicePropertyListJSONOK creates a GetDevicePropertyListJSONOK with default headers values
func NewGetDevicePropertyListJSONOK() *GetDevicePropertyListJSONOK {
	return &GetDevicePropertyListJSONOK{}
}

/* GetDevicePropertyListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDevicePropertyListJSONOK struct {
	Payload interface{}
}

func (o *GetDevicePropertyListJSONOK) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/properties?__json=][%d] getDevicePropertyListJsonOK  %+v", 200, o.Payload)
}
func (o *GetDevicePropertyListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDevicePropertyListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDevicePropertyListJSONTooManyRequests creates a GetDevicePropertyListJSONTooManyRequests with default headers values
func NewGetDevicePropertyListJSONTooManyRequests() *GetDevicePropertyListJSONTooManyRequests {
	return &GetDevicePropertyListJSONTooManyRequests{}
}

/* GetDevicePropertyListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDevicePropertyListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetDevicePropertyListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/properties?__json=][%d] getDevicePropertyListJsonTooManyRequests ", 429)
}

func (o *GetDevicePropertyListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDevicePropertyListJSONDefault creates a GetDevicePropertyListJSONDefault with default headers values
func NewGetDevicePropertyListJSONDefault(code int) *GetDevicePropertyListJSONDefault {
	return &GetDevicePropertyListJSONDefault{
		_statusCode: code,
	}
}

/* GetDevicePropertyListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDevicePropertyListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get device property list Json default response
func (o *GetDevicePropertyListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDevicePropertyListJSONDefault) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/properties?__json=][%d] getDevicePropertyListJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetDevicePropertyListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDevicePropertyListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
