// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetEventSourceListJSONReader is a Reader for the GetEventSourceListJSON structure.
type GetEventSourceListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetEventSourceListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetEventSourceListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetEventSourceListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetEventSourceListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetEventSourceListJSONOK creates a GetEventSourceListJSONOK with default headers values
func NewGetEventSourceListJSONOK() *GetEventSourceListJSONOK {
	return &GetEventSourceListJSONOK{}
}

/* GetEventSourceListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetEventSourceListJSONOK struct {
	Payload interface{}
}

func (o *GetEventSourceListJSONOK) Error() string {
	return fmt.Sprintf("[GET /setting/eventsources?__json=][%d] getEventSourceListJsonOK  %+v", 200, o.Payload)
}
func (o *GetEventSourceListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetEventSourceListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetEventSourceListJSONTooManyRequests creates a GetEventSourceListJSONTooManyRequests with default headers values
func NewGetEventSourceListJSONTooManyRequests() *GetEventSourceListJSONTooManyRequests {
	return &GetEventSourceListJSONTooManyRequests{}
}

/* GetEventSourceListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetEventSourceListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetEventSourceListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/eventsources?__json=][%d] getEventSourceListJsonTooManyRequests ", 429)
}

func (o *GetEventSourceListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetEventSourceListJSONDefault creates a GetEventSourceListJSONDefault with default headers values
func NewGetEventSourceListJSONDefault(code int) *GetEventSourceListJSONDefault {
	return &GetEventSourceListJSONDefault{
		_statusCode: code,
	}
}

/* GetEventSourceListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetEventSourceListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get event source list Json default response
func (o *GetEventSourceListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetEventSourceListJSONDefault) Error() string {
	return fmt.Sprintf("[GET /setting/eventsources?__json=][%d] getEventSourceListJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetEventSourceListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetEventSourceListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
