// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetIntegrationAuditLogsJSONReader is a Reader for the GetIntegrationAuditLogsJSON structure.
type GetIntegrationAuditLogsJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetIntegrationAuditLogsJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetIntegrationAuditLogsJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetIntegrationAuditLogsJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetIntegrationAuditLogsJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetIntegrationAuditLogsJSONOK creates a GetIntegrationAuditLogsJSONOK with default headers values
func NewGetIntegrationAuditLogsJSONOK() *GetIntegrationAuditLogsJSONOK {
	return &GetIntegrationAuditLogsJSONOK{}
}

/* GetIntegrationAuditLogsJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetIntegrationAuditLogsJSONOK struct {
	Payload interface{}
}

func (o *GetIntegrationAuditLogsJSONOK) Error() string {
	return fmt.Sprintf("[GET /setting/integrations/auditlogs?__json=][%d] getIntegrationAuditLogsJsonOK  %+v", 200, o.Payload)
}
func (o *GetIntegrationAuditLogsJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetIntegrationAuditLogsJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIntegrationAuditLogsJSONTooManyRequests creates a GetIntegrationAuditLogsJSONTooManyRequests with default headers values
func NewGetIntegrationAuditLogsJSONTooManyRequests() *GetIntegrationAuditLogsJSONTooManyRequests {
	return &GetIntegrationAuditLogsJSONTooManyRequests{}
}

/* GetIntegrationAuditLogsJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetIntegrationAuditLogsJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetIntegrationAuditLogsJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/integrations/auditlogs?__json=][%d] getIntegrationAuditLogsJsonTooManyRequests ", 429)
}

func (o *GetIntegrationAuditLogsJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetIntegrationAuditLogsJSONDefault creates a GetIntegrationAuditLogsJSONDefault with default headers values
func NewGetIntegrationAuditLogsJSONDefault(code int) *GetIntegrationAuditLogsJSONDefault {
	return &GetIntegrationAuditLogsJSONDefault{
		_statusCode: code,
	}
}

/* GetIntegrationAuditLogsJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetIntegrationAuditLogsJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get integration audit logs Json default response
func (o *GetIntegrationAuditLogsJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetIntegrationAuditLogsJSONDefault) Error() string {
	return fmt.Sprintf("[GET /setting/integrations/auditlogs?__json=][%d] getIntegrationAuditLogsJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetIntegrationAuditLogsJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetIntegrationAuditLogsJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
