// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetRecipientGroupByIDJSONReader is a Reader for the GetRecipientGroupByIDJSON structure.
type GetRecipientGroupByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRecipientGroupByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRecipientGroupByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetRecipientGroupByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetRecipientGroupByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetRecipientGroupByIDJSONOK creates a GetRecipientGroupByIDJSONOK with default headers values
func NewGetRecipientGroupByIDJSONOK() *GetRecipientGroupByIDJSONOK {
	return &GetRecipientGroupByIDJSONOK{}
}

/* GetRecipientGroupByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetRecipientGroupByIDJSONOK struct {
	Payload interface{}
}

func (o *GetRecipientGroupByIDJSONOK) Error() string {
	return fmt.Sprintf("[GET /setting/recipientgroups/{id}?__json=][%d] getRecipientGroupByIdJsonOK  %+v", 200, o.Payload)
}
func (o *GetRecipientGroupByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetRecipientGroupByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRecipientGroupByIDJSONTooManyRequests creates a GetRecipientGroupByIDJSONTooManyRequests with default headers values
func NewGetRecipientGroupByIDJSONTooManyRequests() *GetRecipientGroupByIDJSONTooManyRequests {
	return &GetRecipientGroupByIDJSONTooManyRequests{}
}

/* GetRecipientGroupByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetRecipientGroupByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetRecipientGroupByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/recipientgroups/{id}?__json=][%d] getRecipientGroupByIdJsonTooManyRequests ", 429)
}

func (o *GetRecipientGroupByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetRecipientGroupByIDJSONDefault creates a GetRecipientGroupByIDJSONDefault with default headers values
func NewGetRecipientGroupByIDJSONDefault(code int) *GetRecipientGroupByIDJSONDefault {
	return &GetRecipientGroupByIDJSONDefault{
		_statusCode: code,
	}
}

/* GetRecipientGroupByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetRecipientGroupByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get recipient group by Id Json default response
func (o *GetRecipientGroupByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetRecipientGroupByIDJSONDefault) Error() string {
	return fmt.Sprintf("[GET /setting/recipientgroups/{id}?__json=][%d] getRecipientGroupByIdJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetRecipientGroupByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetRecipientGroupByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
