// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetReportListJSONReader is a Reader for the GetReportListJSON structure.
type GetReportListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetReportListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetReportListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetReportListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetReportListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetReportListJSONOK creates a GetReportListJSONOK with default headers values
func NewGetReportListJSONOK() *GetReportListJSONOK {
	return &GetReportListJSONOK{}
}

/* GetReportListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetReportListJSONOK struct {
	Payload interface{}
}

func (o *GetReportListJSONOK) Error() string {
	return fmt.Sprintf("[GET /report/reports?__json=][%d] getReportListJsonOK  %+v", 200, o.Payload)
}
func (o *GetReportListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetReportListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetReportListJSONTooManyRequests creates a GetReportListJSONTooManyRequests with default headers values
func NewGetReportListJSONTooManyRequests() *GetReportListJSONTooManyRequests {
	return &GetReportListJSONTooManyRequests{}
}

/* GetReportListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetReportListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetReportListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /report/reports?__json=][%d] getReportListJsonTooManyRequests ", 429)
}

func (o *GetReportListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetReportListJSONDefault creates a GetReportListJSONDefault with default headers values
func NewGetReportListJSONDefault(code int) *GetReportListJSONDefault {
	return &GetReportListJSONDefault{
		_statusCode: code,
	}
}

/* GetReportListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetReportListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get report list Json default response
func (o *GetReportListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetReportListJSONDefault) Error() string {
	return fmt.Sprintf("[GET /report/reports?__json=][%d] getReportListJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetReportListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetReportListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
