// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetSDTHistoryByDeviceGroupIDJSONReader is a Reader for the GetSDTHistoryByDeviceGroupIDJSON structure.
type GetSDTHistoryByDeviceGroupIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetSDTHistoryByDeviceGroupIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetSDTHistoryByDeviceGroupIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetSDTHistoryByDeviceGroupIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetSDTHistoryByDeviceGroupIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetSDTHistoryByDeviceGroupIDJSONOK creates a GetSDTHistoryByDeviceGroupIDJSONOK with default headers values
func NewGetSDTHistoryByDeviceGroupIDJSONOK() *GetSDTHistoryByDeviceGroupIDJSONOK {
	return &GetSDTHistoryByDeviceGroupIDJSONOK{}
}

/* GetSDTHistoryByDeviceGroupIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetSDTHistoryByDeviceGroupIDJSONOK struct {
	Payload interface{}
}

func (o *GetSDTHistoryByDeviceGroupIDJSONOK) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}/historysdts?__json=][%d] getSdtHistoryByDeviceGroupIdJsonOK  %+v", 200, o.Payload)
}
func (o *GetSDTHistoryByDeviceGroupIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetSDTHistoryByDeviceGroupIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSDTHistoryByDeviceGroupIDJSONTooManyRequests creates a GetSDTHistoryByDeviceGroupIDJSONTooManyRequests with default headers values
func NewGetSDTHistoryByDeviceGroupIDJSONTooManyRequests() *GetSDTHistoryByDeviceGroupIDJSONTooManyRequests {
	return &GetSDTHistoryByDeviceGroupIDJSONTooManyRequests{}
}

/* GetSDTHistoryByDeviceGroupIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetSDTHistoryByDeviceGroupIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetSDTHistoryByDeviceGroupIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}/historysdts?__json=][%d] getSdtHistoryByDeviceGroupIdJsonTooManyRequests ", 429)
}

func (o *GetSDTHistoryByDeviceGroupIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetSDTHistoryByDeviceGroupIDJSONDefault creates a GetSDTHistoryByDeviceGroupIDJSONDefault with default headers values
func NewGetSDTHistoryByDeviceGroupIDJSONDefault(code int) *GetSDTHistoryByDeviceGroupIDJSONDefault {
	return &GetSDTHistoryByDeviceGroupIDJSONDefault{
		_statusCode: code,
	}
}

/* GetSDTHistoryByDeviceGroupIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetSDTHistoryByDeviceGroupIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get SDT history by device group Id Json default response
func (o *GetSDTHistoryByDeviceGroupIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetSDTHistoryByDeviceGroupIDJSONDefault) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}/historysdts?__json=][%d] getSDTHistoryByDeviceGroupIdJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetSDTHistoryByDeviceGroupIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetSDTHistoryByDeviceGroupIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
