// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetWebsiteGraphDataJSONReader is a Reader for the GetWebsiteGraphDataJSON structure.
type GetWebsiteGraphDataJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetWebsiteGraphDataJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetWebsiteGraphDataJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetWebsiteGraphDataJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetWebsiteGraphDataJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetWebsiteGraphDataJSONOK creates a GetWebsiteGraphDataJSONOK with default headers values
func NewGetWebsiteGraphDataJSONOK() *GetWebsiteGraphDataJSONOK {
	return &GetWebsiteGraphDataJSONOK{}
}

/* GetWebsiteGraphDataJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetWebsiteGraphDataJSONOK struct {
	Payload interface{}
}

func (o *GetWebsiteGraphDataJSONOK) Error() string {
	return fmt.Sprintf("[GET /website/websites/{websiteId}/checkpoints/{checkpointId}/graphs/{graphName}/data?__json=][%d] getWebsiteGraphDataJsonOK  %+v", 200, o.Payload)
}
func (o *GetWebsiteGraphDataJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetWebsiteGraphDataJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetWebsiteGraphDataJSONTooManyRequests creates a GetWebsiteGraphDataJSONTooManyRequests with default headers values
func NewGetWebsiteGraphDataJSONTooManyRequests() *GetWebsiteGraphDataJSONTooManyRequests {
	return &GetWebsiteGraphDataJSONTooManyRequests{}
}

/* GetWebsiteGraphDataJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetWebsiteGraphDataJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetWebsiteGraphDataJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /website/websites/{websiteId}/checkpoints/{checkpointId}/graphs/{graphName}/data?__json=][%d] getWebsiteGraphDataJsonTooManyRequests ", 429)
}

func (o *GetWebsiteGraphDataJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetWebsiteGraphDataJSONDefault creates a GetWebsiteGraphDataJSONDefault with default headers values
func NewGetWebsiteGraphDataJSONDefault(code int) *GetWebsiteGraphDataJSONDefault {
	return &GetWebsiteGraphDataJSONDefault{
		_statusCode: code,
	}
}

/* GetWebsiteGraphDataJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetWebsiteGraphDataJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get website graph data Json default response
func (o *GetWebsiteGraphDataJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetWebsiteGraphDataJSONDefault) Error() string {
	return fmt.Sprintf("[GET /website/websites/{websiteId}/checkpoints/{checkpointId}/graphs/{graphName}/data?__json=][%d] getWebsiteGraphDataJson default  %+v", o._statusCode, o.Payload)
}
func (o *GetWebsiteGraphDataJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetWebsiteGraphDataJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
